/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_2_1_c_f.cpp

     Summary:           don't delete a dynamically created variable

     Test description:  the pointer is a default member variable; the allocation and a pointer copy to a global pointer are in a virtual member function; "float" is used for the base datatype of the pointer

     Error line:        

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          deallocate, default member variable, memory consumption, missing delete, virtual member function

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassBase {
    protected:
        virtual void runA()=0;
};

class TestClass : public TestClassBase {
        // this is the declaration of the pointer
        float *ptrA;

    public:
        void runA();
};

void TestClass :: runA() {
    // allocate memory
    cout << "allocate memory" << endl;
    ptrA=new float;

    // initialize ptrA
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
