/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_2_1_m_d.cpp

     Summary:           don't delete a dynamically created variable

     Test description:  the pointer is declared in the main function and passed as a reference argument to the member function "run"; the allocation and a pointer copy to a global pointer are in the member function "run"; "double" is used for the base datatype of the pointer

     Error line:        

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          passing, reference, argument, deallocate, memory consumption, missing delete

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        void runA(double *&ptrA);
};

void TestClass :: runA(double *&ptrA) {
    // allocate memory
    cout << "allocate memory" << endl;
    ptrA=new double;

    // initialize ptrA
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

int main() {
    TestClass testclassA;
    // this is the declaration of the pointer
    double *ptrA;

    testclassA.runA(ptrA);

    return EXITCODE_OK;
}
