/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_1_e_ld.cpp

     Summary:           use "malloc" with "delete"

     Test description:  the pointer is a default member variable; the allocation with "malloc" is in the constructor; the deallocation with "delete" is in a friend function; "long double" is used for the base datatype of the pointer

     Error line:        60

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          friend function, constructor, default member variable, delete, malloc

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
        friend void runA();
        // this is the declaration of the pointer
        long double *ptrA;

    public:
        TestClassData();
};

TestClassData :: TestClassData() {
    // C-style allocation
    cout << "C-style allocation" << endl;
    ptrA=(long double *) malloc( sizeof(long double) );

    // initialize *ptrA
    *ptrA=rand();
}

TestClassData classdataA;

// this is the friend function
void runA() {
    // outsmart dead code elimination
    cout << "classdataA.ptrA " << &classdataA.ptrA << ", " << classdataA.ptrA << ", " << *classdataA.ptrA << endl;

    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete classdataA.ptrA;
}

int main() {
    runA();
    return EXITCODE_OK;
}
