/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_1_g_d.cpp

     Summary:           use "malloc" with "delete"

     Test description:  the pointer is a base class member variable; the allocation with "malloc" is in the constructor of the base class; the deallocation with "delete" is in a member function of the inheriting class; "double" is used for the base datatype of the pointer

     Error line:        62

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          inherited class, member function, member variables, constructor, delete, malloc

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassBase {
    protected:
        // this is the declaration of the pointer
        double *ptrA;

    public:
        TestClassBase();
};

TestClassBase :: TestClassBase() {
    // C-style allocation
    cout << "C-style allocation" << endl;
    ptrA=(double *) malloc( sizeof(double) );

    // initialize *ptrA
    *ptrA=rand();
}

class TestClass : public TestClassBase {
    public:
        void runA();
};

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete ptrA;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
