/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_1_i_f.cpp

     Summary:           use "malloc" with "delete"

     Test description:  the pointer is a public member variable of the class "TestClassData"; the allocation with "malloc" is in the constructor of the class "TestClassData"; the deallocation with "delete" is in a member function of the class "TestClass"; "float" is used for the base datatype of the pointer

     Error line:        62

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          class, member function, public member variable, constructor, delete, malloc

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
    public:
        TestClassData();
        // this is the declaration of the pointer
        float *ptrA;
};

TestClassData :: TestClassData() {
    // C-style allocation
    cout << "C-style allocation" << endl;
    ptrA=(float *) malloc( sizeof(float) );

    // initialize *ptrA
    *ptrA=rand();
}

TestClassData classdataA;

class TestClass {
    public:
        void runA();
};

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "classdataA.ptrA " << &classdataA.ptrA << ", " << classdataA.ptrA << ", " << *classdataA.ptrA << endl;

    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete classdataA.ptrA;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
