/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_1_k_ld.cpp

     Summary:           use "malloc" with "delete"

     Test description:  the pointer is declared in the main function and passed as a value argument to the member function "run"; the allocation with "malloc" is in the main function; the deallocation with "delete" is in the member function "run"; "long double" is used for the base datatype of the pointer

     Error line:        44

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          argument, passing, delete, main function, malloc

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        void runA(long double *ptrA);
};

void TestClass :: runA(long double *ptrA) {
    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete ptrA;
}

int main() {
    TestClass testclassA;
    // this is the declaration of the pointer
    long double *ptrA;
    // C-style allocation
    cout << "C-style allocation" << endl;
    ptrA=(long double *) malloc( sizeof(long double) );

    // initialize *ptrA
    *ptrA=rand();
    testclassA.runA(ptrA);
    return EXITCODE_OK;
}
