/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_2_h_ld.cpp

     Summary:           use "new" with "free"

     Test description:  the pointer is a "static" member variable; the allocation with "new" is in the constructor; the deallocation with "free" is in a member function; "long double" is used for the base datatype of the pointer

     Error line:        60

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          member function, static member variable, constructor, free, new

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        static long double *ptrA;

    public:
        TestClass();
        void runA();
};

// this is the definition of the pointer
long double *TestClass::ptrA;

TestClass :: TestClass() {
    // C++ style allocation
    cout << "C++ style allocation" << endl;
    ptrA=new long double;

    // initialize *ptrA
    *ptrA=rand();
}

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    // C style deallocation
    cout << "C style deallocation" << endl;
    free(ptrA);
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
