/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_3_k_ld.cpp

     Summary:           use "calloc" with "delete []"

     Test description:  the pointer to the array is declared in the main function and passed as a value argument to the member function "run"; the allocation with "calloc" is in the main function; the deallocation with "delete []" is in the member function "run"; "long double" is used for the base datatype of the pointer to the array

     Error line:        48

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          argument, passing, calloc, delete, main function

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        void runA(long double *arrayA);
};

void TestClass :: runA(long double *arrayA) {
    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE]  << endl;

    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete [] arrayA;
}

int main() {
    TestClass testclassA;
    // this is the declaration of the pointer
    long double *arrayA;
    // C-style allocation
    cout << "C-style allocation" << endl;
    arrayA=(long double *) calloc(SIZE, sizeof(long double));

    // initialize arrayA
    cout << "fill the array with random values" << endl;
    for ( int i=0; i < SIZE; i++) {
        arrayA[i]=rand();
    }
    testclassA.runA(arrayA);
    return EXITCODE_OK;
}
