/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_1_n_ld.cpp

     Summary:           use "delete" twice with the same pointer

     Test description:  the pointer is declared in the main function and passed as a value argument to the template member function "run"; the allocation is in the main function; one delete is in the main function; the additional delete is in a template function; "long double" is used for the base datatype of the pointer

     Error line:        63

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          argument, passing, template, deallocate twice, delete, main function, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        template <class T> void runA(T *ptrA);
};

template <class T> void TestClass :: runA(T *ptrA) {
    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
}

int main() {
    TestClass testclassA;
    // this is the declaration of the pointer
    long double *ptrA;

    // memory allocation
    cout << "allocation" << endl;
    ptrA=new long double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    testclassA.runA(ptrA);

    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
    return EXITCODE_OK;
}
