/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_3_a_d.cpp

     Summary:           use "delete" with a pointer and a copy of the pointer

     Test description:  both pointers are default member variables; the allocation is in the constructor; the copy of the pointer is in a member function; both deallocations are in the destructor; "double" is used for the base datatype of the pointer

     Error line:        57

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          constructor, member function, copy, deallocate twice, default member variable, delete, destructor, pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        double *ptrA;
        double *ptrAcopy;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    // memory allocation
    cout << "memory allocation for ptrA" << endl;
    ptrA=new double;

    // initialize
    *ptrA=rand();
}

TestClass :: ~TestClass() {
    // memory deallocation
    cout << "memory deallocation of ptrA and ptrAcopy" << endl;
    delete ptrA;
    delete ptrAcopy;
}

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    // copy the memory address from ptrA into ptrAcopy
    cout << "ptrA -> ptrAcopy" << endl;
    ptrAcopy=ptrA;

    // outsmart dead code elimination
    cout << "ptrAcopy " << &ptrAcopy << ", " << ptrAcopy << ", " << *ptrAcopy << endl;

}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
