/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_1_1_b.c
*
*    Test description:	Deallocate memory that has never been allocated. 
*                       Call free() in a function using a pointer passed 
*                       by address from main function; the pointer has an address 
*                       of stack memory variable.
*                       The file must be compiled with file c_G_1_1_b.c
*
*    Error line:        32
*
*    Keywords:		memory deallocation error
*                       free stack memory
*                       function
*			free()
*                       int
*
*    Last modified:	June 30, 2005
*/

#include <stdlib.h>

void func(int **ptrA)
{
    free(*ptrA);  /* deallocate stack memory */
}
