/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_4_b.c
*
*    Test description:	Reallocate memory with a dangling pointer.
*                       Point the pointer to a freed pointer, 
*                       pass it by address to a function, 
*                       and reallocate the memory there.
*
*    Support files:     c_G_2_4_b_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		reallocate memory with incorrect pointer
*                       function
*                       freed pointer
*			realloc()
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(int **ptrA);

int main(void)
{
   int *ptrA, *ptrB;
   int i;

   ptrA = (int *)malloc(sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   *ptrA = 0;
   ptrB = (int *)malloc(N*sizeof(int));
   if(!ptrB)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrB[i] = N - i;
   for(i=0;i<N;i++) *ptrA = *ptrA + ptrB[i];
   
   free(ptrB); 

   ret();
   if(ret1!=1) printf("%d\n", *ptrA);     /* the value of ret1 = 1 */
   free(ptrA);
   ptrA = ptrB;
 
   func(&ptrA);

   return EXITCODE_OK;
}


