/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_3_a.c
*
*    Test description:	Allocate a block of memory and do not deallocate it. 
*
*    Error line:        53
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory deallocation error
*                       int
*
*    Last modified:	June 29, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int *ptrA, sum = 0;
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */

   return EXITCODE_OK; 
}
