/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_2_1_c.c
*
*    Test description:	Read one element before the lower bound of a stack array
*			using an array of indexes. The array is passed to a function.
*			The file must be compiled with file c_E_2_1_c.c
*
*    Error line:        38
*
*    Keywords:		out-of-bounds
*			stack array
*			array indexing
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(int *arrayA)
{
    int c;
    int i, index[N];
    
    for(i=0; i<N; i++)
        index[i] = i-1;
    c = arrayA[index[0]];  /* read one element before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}

