/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_4_3_b.c
*
*    Test description:	Read one element past the upper bound of 
*			a dynamically allocated array using a subscript.
*			The array is declared and used in a function.
*			The file must be compiled with file c_E_4_3_b.c
*
*    Error line:        49
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 29, 2005
*/

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

#include "TEST_PARAM.H"

int func(void)
{
   int b, *ptr;
   int i;

   ptr = (int *)malloc(N*sizeof(int));
   if(!ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
        ptr[i] = i;
   b = ptr[i];  /* read one element past the upper bound */

   free(ptr);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable b=%d", b);
   } 

   return ret2;
}

