/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_4_4_b.c
*
*    Test description:	Write one element past the upper bound of  
*			a dynamically allocated array using a subscript.
*			The array is declared and used in a function.
*
*    Support files:     c_E_4_4_b_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			function
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 29, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include <stdio.h> 

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(void);

int main(void)
{
   int a;

   a = func();

   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
}
