/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_4_6_e.c
*
*    Test description:	Write K elements before the lower bound of 
*			a dynamically allocated array of structures
*			declared in a function. Use array indexing.
*			The file must be compiled with file c_E_4_6_e.c
*
*    Error line:        53
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			array of structures
*			function
*			write
*                       int
*
*    Last modified:	July 29, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int b = 0, sum = 0;
   int i;
   struct aab {
       char * nm;
       int c;
   } *ptr;

   ptr = (struct aab *)malloc(N*sizeof(struct aab));
   if(!ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       ptr[i].c = i;
   i = i - N - K;
   ptr[i].c = b;  /* write K elements before the lower bound */
   for(i=0; i<N; i++)
       sum = sum + ptr[i].c;

   free(ptr);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

