/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_5_4_c.c
*
*    Test description:	Write one element past the second dimension bound but within  
*			a dynamically allocated multidimensional array 
*			using a subscript.
*			The array is declared in main function and 
*			passed to a function as an argument.
*
*    Support files:     c_E_5_4_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			multidimensional array
*			function
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 30, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include <stdio.h> 
#include <stdlib.h> 
#include "TEST_CONST.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(int **ptr, int i);

int main(void)
{
   int **ptr;
   int a, i, j;

   ptr = (int **)malloc(N*sizeof(int *));
   if(!ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
    {
       ptr[i] = (int *)malloc(N*sizeof(int));
       if(!ptr[i])
        { 
          printf("Out of memory.\n");
          exit(EXITCODE_ERROR);
        }   
    }
   for(i=0; i<N; i++)
       for(j=0; j<N; j++)
           ptr[i][j] = i+j;
   i = i - N - 1;
   a = func(ptr,i);

   for(i=0; i<N; i++)
       free(ptr[i]);
   free(ptr);
   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
}
