/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_B_2_1_a_i.cpp

     Summary:           overflow in a sum

     Test description:  varO is a default member variable; the sum is in a member function; "int" is used for varV

     Error line:        50

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          overloaded operator, sum, default member variable, member function, overflow

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>

#ifndef SUM
#define SUM 0xff
#endif

// this is the declaration of the class that has an overloaded "operator +"
class OperatorClass {
        int varV;

    public:
        // the "operator =" stores a new value in varV
        void operator=(const int& value) {
            varV=value;
        }

        // this operator is used in the while loop
        bool operator < (const OperatorClass& varR) {
            cout << varV << endl;
            return varR.varV < varV;
        }

        // this is the "operator +" where the overflow should occur
        int operator + (const OperatorClass& varR) {
            return varV + varR.varV;
        }
};

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the object that has an overloaded "operator +"
        OperatorClass varO;

    public:
        void runA();
};

void TestClass :: runA() {
    // varO is initialized with SUM
    varO=SUM;

    // varO2 is used to store the previous varO
    OperatorClass varO2;

    // this while computes varO := varO + varO as long as varO < varO + varO
    do {
        varO2=varO;
        varO=varO + varO;
    } while ( varO < varO2 );
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
