/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_H_1_3_a_fs.cpp

     Summary:           read from a file that was open for output

     Test description:  the file stream is a default member variable; the open is in the constructor; the read is in a member function; the close is in the destructor; "fstream" is used for the file stream

     Error line:        65

     Support files:     Not needed

     Env. requirements: Write and read access to create a file for testing

     Keywords:          constructor, member function, output, read, default member variable, destructor, file stream

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>
#include <fstream.h>

#ifndef FILENAME
#define FILENAME "fileA.txt"
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // declaration of the file stream
        fstream streamA;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    // open the file stream
    streamA.open(FILENAME, ios::out);
    if (!streamA) {
        cerr << "Cannot open file " << FILENAME << "." << endl;
        exit(EXITCODE_ERROR);
    }
}

TestClass :: ~TestClass() {
    // try to read from this stream
    char charA;
    cout << "read from the file " << FILENAME << endl;
    streamA >> charA;

    // dead-code elmination
    cout << charA << endl;
}

void TestClass :: runA() {
    // close the file stream
    streamA.close();
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
