/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_1_1_g_d.cpp

     Summary:           use "new" twice with the same pointer

     Test description:  the pointer is a base class member variable; one allocation is in the constructor of the base class; the second allocation is in a member function of the inheriting class; one deallocation is in the destructor of the base class; "double" is used for the base datatype of the pointer

     Error line:        69

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          constructor, inherited class, member function, member variables, allocate twice, destructor, new, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassBase {
    protected:
        // this is the declaration of the pointer
        double *ptrA;

    public:
        TestClassBase();
        ~TestClassBase();
};

TestClassBase :: TestClassBase() {
    // memory allocation
    cout << "allocation by using new" << endl;
    ptrA=new double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

TestClassBase :: ~TestClassBase() {
    // memory deallocation
    cout << "deallocation by using delete" << endl;
    delete ptrA;
}

class TestClass : public TestClassBase {
    public:
        void runA();
};

void TestClass :: runA() {
    // memory allocation
    cout << "allocation by using new" << endl;
    ptrA=new double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
