/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_1_1_n_ld.cpp

     Summary:           use "new" twice with the same pointer

     Test description:  the pointer is a "static" member variable; the allocation is in the constructor; the delete is in the destructor; 2 objects of this class are create; "long double" is used for the base datatype of the pointer.

     Error line:        50

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocate twice, new, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass
{
        // this is the declaration of the pointer
        static long double *ptrA;

    public:
        TestClass();
        ~TestClass();
};

// this is the definition of the pointer
long double *TestClass::ptrA;

TestClass :: TestClass()
{
    // memory allocation
    cout << "allocation" << endl;
    ptrA=new long double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

TestClass :: ~TestClass()
{
    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
}

int main()
{
    TestClass testclassA;
    TestClass testclassB;
    return EXITCODE_OK;
}
