/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_3_2_a_d.cpp

     Summary:           overwrite the pointer to an array with zero

     Test description:  the pointer is a default member variable; the allocation is in the constructor; the altering of the pointer is in a member function; the deallocation is in the destructor; "double" is used for the datatype of the array

     Error line:        74

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          array, constructor, member function, overwrite, allocate, default member variable, destructor

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        double *arrayA;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    // memory allocation
    cout << "allocation by using new []" << endl;
    arrayA=new double [SIZE];

    // initialize arrayA
    cout << "fill the array with random values" << endl;
    for ( int i=0; i < SIZE; i++) {
        arrayA[i]=rand();
    }
}

TestClass :: ~TestClass() {
    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE]  << endl;

    // memory deallocation
    cout << "deallocation by using delete" << endl;
    delete [] arrayA;
}

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE]  << endl;

    // modify the pointer by setting it to zero
    cout << "modify pointer" << endl;
    arrayA=0;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
