/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .
*    Test name:		c_I_1_a.c
*
*    Test description:	Allocate memory twice using the same pointer 
*                       without deallocating it first 
*                       and without associating another pointer   
*                       with the first block of memory. 
*                       Use a pointer in a function.
*                       The file must be compiled with file c_I_1_a.c
*
*    Error line:        47
*
*    Keywords:		memory leak
*                       double allocation
*                       unreferenced memory
*			function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(void)
{
   int *ptrA, sum = 0;
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];

   ptrA = (int *)malloc(sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   *ptrA = sum/N;
    
   ret();
   if(ret1!=1) printf("%d\n", *ptrA);     /* the value of ret1 = 1 */

   free(/*DEALLOC*/ptrA);
}
