/*
*    Test name:		c_I_1_b.c
*
*    Test description:	Allocate memory twice using the same pointer 
*                       without deallocating it first 
*                       and without associating another pointer   
*                       with the first block of memory. 
*                       The pointer is a member of a structure in a function.
*                       The file must be compiled with file c_I_1_b.c
*
*    Error line:        48
 *
*    Keywords:		memory leak
*                       double allocation
*                       unreferenced memory
*			function
*			structure
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(void)
{
   int sum = 0;
   struct aab {
       char * name[5];
       int *ptrA;
   } ss;
   int i;

   ss.ptrA = (int *)malloc(N*sizeof(int));
   if(!ss.ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ss.ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ss.ptrA[i];

   ss.ptrA = (int *)malloc(sizeof(int));
   if(!ss.ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   *ss.ptrA = sum/N;
    
   ret();
   if(ret1!=1) printf("%d\n", *ss.ptrA);     /* the value of ret1 = 1 */

   free(/*DEALLOC*/ss.ptrA);
}
