/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_1_e.c
*
*    Test description:	Allocate memory twice using the same pointer 
*                       without deallocating it first 
*                       and without associating another pointer   
*                       with the first block of memory. 
*                       Use a global pointer to allocate memory in two
*                       different units (functions).
*                       The file must be compiled with file c_I_1_e.c
*
*    Error line:        58
*
*    Keywords:		memory leak
*                       double allocation
*                       unreferenced memory
*                       global pointer
*			function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int *ptrA;
extern int sum;

void func_1(void)
{
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */
}

void func_2(void)
{
   ptrA = (int *)malloc(sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   *ptrA = sum/N;
    
   ret();
   if(ret2!=1) printf("%d\n", *ptrA);     /* the value of ret2 = 1 */

   free(/*DEALLOC*/ptrA);
}
