/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_5_a.c
*
*    Test description:	Allocate memory in a block, do not deallocate it upon exit 
*                       from the block without associating another pointer with it.
*
*    Support files:     c_I_5_a_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory leak
*                       unreferenced memory
*			block
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int *ptrA, sum = 0;
   int i;

   { 
     int *ptrA;
     ptrA = (int *)malloc(N*sizeof(int));
     if(!ptrA)
      { 
        printf("Out of memory.\n");
        exit(EXITCODE_ERROR);
      }   
     for(i=0;i<N;i++) ptrA[i] = N - i;
     for(i=0;i<N;i++) sum = sum + ptrA[i];
   }
   
   ptrA = &sum; 
   *ptrA = *ptrA/N;

   ret();
   if(ret1!=1) printf("%d\n", *ptrA);     /* the value of ret1 = 1 */
 
   return EXITCODE_OK;
}
