/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_5_b.c
*
*    Test description:	Allocate memory in a function, do not deallocate it upon exit 
*                       from the function without associating another pointer with it.
*                       The file must be compiled with file c_I_5_b.c
*
*    Error line:        46
*
*    Keywords:		memory leak
*                       unreferenced memory
*			function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(void)
{
   int *ptrA, sum = 0;
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];
    
   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */
}
