/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_J_1_3_a_d.cpp

     Summary:           call a member function by using an object pointer that has a null value and access a member variable

     Test description:  the pointer of the object is a global variable; the pointer is set to null in the main function; the call of a member function by using the null pointer is in the main function.

     Error line:        40

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          call, function, null, object, pointer, address

     Last modified:     10/12/2005 20:26

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass
{
        int varA;

    public:
        void runA() {
            // this pointer is NULL !!!
            varA=rand();

            // outsmart dead code elimination
            if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10)
            {
                cout << "this should never be called" << endl;
                varA--;
            }
            cout << "address" << &varA << endl;
            cout << "value " << varA << endl;
        };
};

TestClass *testclassA;

int main()
{
    // set the pointer testclassA to null
    testclassA=0;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10)
    {
        cout << "this should never be called" << endl;
        testclassA=new TestClass;
    }

    // invalid acces by using a null pointer
    cout << "access by using a null pointer" << endl;
    testclassA->runA();

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10)
    {
        cout << "this should never be called" << endl;
        delete testclassA;
    }

    return EXITCODE_OK;
}
