/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_3_b.c
*
*    Test description:	Read one element past the upper bound of 
*			a single-dimensional stack array declared and used 
*			in a function. Use pointer reference.
*			The file must be compiled with file c_F_1_3_b.c
*
*    Error line:        43
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int arrayA[N], c, *ptr; 
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptr = arrayA;
   ptr+=N;
   c = *ptr;  /* read one element past the upper bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}
