/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_5_d.c
*
*    Test description:	Read K elements before the lower bound of 
*			a single-dimensional stack array declared and used 
*			in a function as a member of a structure. 
*			Use pointer reference.
*			The file must be compiled with file c_F_1_5_d.c
*
*    Error line:        47
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			function
*			structure
*			read
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c, *ptr; 
   struct aab {
       char * nm;
       int arrayA[N];
   } ss;
   int i;

   for(i=0; i<N; i++)
       ss.arrayA[i] = i;
   ptr = ss.arrayA;
   ptr-=K;
   c = *ptr;  /* read K elements before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}
