/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_1_e.c
*
*    Test description:	Read one element before the lower bound of
*			a dynamically allocated array of structures 
*                       declared and used in a function. 
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*
*    Support files:     c_F_2_1_e_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			array of structures
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include <stdio.h> 

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(void);

int main(void)
{
   int a;

   a = func();

   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
}
