/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_7_c.c
*
*    Test description:	Read K elements past the upper bound of 
*			a dynamically allocated array declared in main function
*			and passed by another pointer to a function where it is used.
*
*    Support files:     c_F_1_1_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			function
*			read
*                       int
*
*    Last modified:	July 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include <stdio.h> 
#include <stdlib.h>
#include "TEST_CONST.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(int *ptr);

int main(void)
{
   int a, *arrayA, *ptr;
   int i;

   arrayA = (int *)malloc(N*sizeof(int));
   if(!arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptr = arrayA;
   a = func(ptr);

   free(arrayA);
   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
}
