/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_8_e.c
*
*    Test description:	Write K elements past the upper bound of
*			a dynamically allocated array of structures 
*                       declared and used in a function. 
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*			The file must be compiled with file c_F_2_8_e.c
*
*    Error line:        60
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			array of structures
*			function
*			write
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int c = 0, sum = 0; 
   int i;
   struct aab {
       char * nm;
       int b;
   } *arrayA, *ptr;

   arrayA = (struct aab *)malloc(N*sizeof(struct aab));
   if(!arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       arrayA[i].b = i;
   ptr = arrayA;
   for(i=0; i<N; i++)          /* use elements of the array */
       sum = sum + ptr[i].b;   /* to prevent code elimination */ 
   ptr+=(N+K-1);
   ptr->b = c;  /* write K elements past the upper bound  of the array of structures */

   free(arrayA);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 
   
   return ret2; 
}
