/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_D_2_4_a.c
*
*    Test description:	Copy upto n characters from str2 to str1 
*                       using strncpy(str1, str2, n) when str1 and str2 overlap.
*                       The strings are dynamically allocated.
*
*    Error line:        57
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		string
*                       dynamically allocated memory
*                       overlap
*                       strncpy
*
*    Last modified:	June 21, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
  char *str1, *str2;
  char str3[]="last";
  int n=sizeof(str3);

  str2 = (char *)malloc(4*n*sizeof(char));
  if(!str2)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   
  strcpy(str2,"test the string");
  str1 = &str2[6];

  strncpy(str1,str2,n);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n",str1); /* use the value to prevent code elimination */
  free(str2);

  return EXITCODE_OK; 
}
