/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_D_2_7_a.c
*
*    Test description:	Use not null-terminated string as an argument 
*                       of function strlen(str1).
*                       The string is dynamically allocated.
*
*    Error line:        69
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		string
*                       dynamically allocated memory
*                       read overflow
*                       not null-terminated string
*                       strlen
*
*    Last modified:	June 20, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
  char *str1, *str2;
  char str3[]="last string";
  int n=sizeof(str3);
  int i, len;

  str1 = (char *)malloc(2*n*sizeof(char));
  if(!str1)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   
  strcpy(str1,"ifmmp!xpsme");

  str2 = (char *)malloc(2*n*sizeof(char));
  if(!str2)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   
  memset(str2,'x',2*n);
      
  for(i=0; i<strlen(str1); i++)
      str2[i]=str1[i]-1;

  len = strlen(str2);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("Length of the string %s is %d\n",str2,len); 
  free(str1);
  free(str2);
     
  return EXITCODE_OK; 
}
