/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:         c_D_2_7_d.c
*
*    Test description:	Use not null-terminated string as a first argument 
*                       of function strchr(str1, c).
*                       The string is dynamically allocated.
*
*    Error line:        61
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:          string
*                       dynamically allocated memory
*                       read overflow
*                       not null-terminated string
*                       strchr
*
*    Last modified:     June 20, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
  char *str1;
  char str2[]="last string";
  int n=sizeof(str2);
  char c = 'a';
  char *p;
  int i;

  str1 = (char *)malloc(n*sizeof(char));
  if(!str1)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   
  for(i=0; i<n;i++)
      str1[i]='x';

  p = strchr(str1,c);
  if (p!=NULL) *p = 'A';

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n %s \n", str1, str2); 
  free(str1);

  return EXITCODE_OK;
}
