/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:         c_D_2_7_g.c
*
*    Test description:	Use not null-terminated string as a first argument 
*                       of function strstr(str1, str2).
*                       The strings are dynamically allocated.
*
*    Error line:        70
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:          string
*                       dynamically allocated memory
*                       read overflow
*                       not null-terminated string
*                       strstr
*
*    Last modified:     June 20, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
  char *str1;
  char *str2;
  char str3[]="last";
  int n=sizeof(str3);
  char *p;
  int i;

  str1 = (char *)malloc(4*n*sizeof(char));
  if(!str1)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   

  str2 = (char *)malloc(n*sizeof(char));
  if(!str2)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   

  for(i=0; i<sizeof(str1);i++)
      str1[i]='x';
  strcpy(str2,"la");

  p = strstr(str1,str2);

  if (p!=NULL) *p = 'A';

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n %s \n", str1, str2); 
  free(str1);
  free(str2);

  return EXITCODE_OK;
}
