/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_1_1_f_d.cpp

     Summary:           read an uninitialized variable

     Test description:  the uninitialized variable is a default member variable; the read is in a friend function; "double" is used for the uninitialized variable

     Error line:        57

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          read, default member variable, friend function, uninitialized variable

     Last modified:     10/14/2005 10:08

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
    private:
        friend void runA();
        // this is the declaration of the uninitialized variable
        double varA;
};

// this is the friend function
void runA() {
    TestClassData classdataA;

    // varB is used to store the value of varA
    double varB;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        classdataA.varA=rand();
    }

    // varA is still uninitialized
    cout << "read" << endl;

    // this is where the read occurs
    varB=classdataA.varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    runA();
    return EXITCODE_OK;
}
