/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_1_1_o_w.cpp

     Summary:           read an uninitialized variable

     Test description:  the uninitialized variable is a default member variable; the read is in a member function of a friend class; "wchar_t" is used for the uninitialized variable

     Error line:        60

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          class, default member variable, member function, read, friend, uninitialized variable

     Last modified:     10/14/2005 10:08

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
        friend class TestClass;
        // this is the declaration of the uninitialized variable
        wchar_t varA;
};

class TestClass {
        TestClassData classdataA;

    public:
        void runA();
};

void TestClass :: runA() {
    // varB is used to store the value of varA
    wchar_t varB;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        classdataA.varA=rand();
    }

    // varA is still uninitialized
    cout << "read" << endl;

    // this is where the read occurs
    varB=classdataA.varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
