/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_1_2_a_i.cpp

     Summary:           read an uninitialized variable by using a pointer

     Test description:  the uninitialized variable is a default member variable; the read is in a member function; "int" is used for the uninitialized variable

     Error line:        62

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          read, default member variable, member function, pointer, uninitialized variable

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the uninitialized variable
        int varA;


    public:
        void runA();
};

void TestClass :: runA() {
    // varB is used to store the value of varA
    int varB;
    int varC=rand();

    // ptrA is used as a pointer to varA
    int *ptrA;
    ptrA=&varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        ptrA=&varC;
        varA=rand();
    }

    // varA is still uninitialized
    cout << "read by using pointer" << endl;

    // this is where the read occurs
    varB=*ptrA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
