/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_1_4_a_i.cpp

     Summary:           read an entry from an uninitialized array

     Test description:  the uninitialized array is a default member variable; the read is in a member function; "int" is used for the uninitialized variable

     Error line:        60

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          array, default member variable, member function, read, uninitialized variable

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the uninitialized array
        int arrayA[SIZE];

    public:
        void runA();
};

void TestClass :: runA() {
    // varB is used to store a value of arrayA
    int varB;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        for ( int i=0; i < SIZE; i++) {
            arrayA[i]=rand();
        }
    }

    // this is where the read occurs
    int i=SIZE/2;
    cout << "read arrayA[" << i << ']' << endl;
    varB=arrayA[i];

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
        for ( int i=0; i < SIZE; i++) {
            cout << arrayA[i] << endl;
        }
    }
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
