/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_3_2_c_uc.cpp

     Summary:           write a variable by using an uninitialized pointer

     Test description:  the uninitialized pointer is a default member variable; the write is in an inline member function; "unsigned char" is used for the variable

     Error line:        53

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          write, default member variable, inline member function, uninitialized pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    private:
        // this is the declaration of the pointer
        unsigned char *ptrA;

    public:
        void runA() {
            // varA is used to store the value that ptrA points to
            unsigned char varA=10;

            // outsmart dead code elimination
            if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
                cout << "this should never be called" << endl;
                ptrA=(unsigned char*) rand();
            }

            // ptrA is not initialized
            cout << "write in *ptrA" << endl;

            // this is where the write occurs
            *ptrA=varA;

            // outsmart dead code elimination
            if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
                cout << "this should never be called" << endl;
                cout << ptrA << endl;
            }
        }
};

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
