/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_3_2_f_l.cpp

     Summary:           write a variable by using an uninitialized pointer

     Test description:  the uninitialized pointer is a default member variable; the write is in a friend function; "long" is used for the variable

     Error line:        57

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          write, default member variable, friend function, uninitialized pointer

     Last modified:     10/14/2005 10:15

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
    private:
        friend void runA();
        // this is the declaration of the pointer
        long *ptrA;
};

// this is the friend function
void runA() {
    TestClassData classdataA;

    // varA is used to store the value that ptrA points to
    long varA=10;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        classdataA.ptrA=(long*) rand();
    }

    // ptrA is not initialized
    cout << "write in *ptrA" << endl;

    // this is where the write occurs
    *classdataA.ptrA=varA;

    // output ptrA
    cout << classdataA.ptrA << endl;
}

int main() {
    runA();
    return EXITCODE_OK;
}
