/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_12_e.c
*
*    Test description:	Use cast operator with an uninitialized variable
*			that is declared and used in main function.
*			Convert double to char.
*
*    Error line:        47
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			main function
*                       cast operator
*                       explicit type conversion
*                       convert double to char
*
*    Last modified:	June 22, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   double varA;
   char varB[10];
    
   ret();
   if(ret1 != 1) varA = 1.012345;

   memset(varB,(char)varA,10);     /* convert double to char */ 

   if(ret2!=1) printf("%c", varB);     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
