/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_2_a_in.c
*
*    Test description:	Read an uninitialized stack array declared in a block
*			using array indexing.
*
*    Error line:        53
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			stack array
*			main function
*			array indexing
*			block
*			int
*
*    Last modified:	May 27, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   int arrayA[5], b = 0;
   int i;
    
   for(i=0; i<5; i++) arrayA[i] = i;

/* Read an uninitialized variable in a block */
   {   
     int arrayA[10];

     ret();
     if(ret1 != 1) {                         /* the value of ret1 = 1 */
        for(i=0; i<10; i++) arrayA[i] = i;
        }
     b = b + arrayA[0];  
   }
   
   if(ret2==0) printf("Variable b=%d", b);   /* the value of ret2 = 1 */
       
   return EXITCODE_OK; 
}
