/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_2_c_in.c
*
*    Test description:	Read an uninitialized stack array in a function
*			using array indexing.
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_A_2_c_in_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			stack array
*			function
*			array indexing
*			int
*
*    Last modified:	May 27, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include <stdio.h> 

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(void);

int main(void)
{
   int a;
    
/* Read from an uninitialized array in a function */

   a = func();
   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
}
