/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_5_d_ui.c
*
*    Test description:	Read an uninitialized dynamically allocated array 
*			passed to a function. Use pointer arithmetic.
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_A_5_d_ui_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			dynamically allocated array
*			function
*			pointer arithmetic
*			unsigned int
*
*    Last modified:	June 1, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(unsigned int *ptrA, int ret1);

int main(void)
{
   unsigned int *ptrA;
   int b, i;
    
   ptrA = (unsigned int *)malloc(10*sizeof(unsigned int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   ret();
   if(ret1 != 1) {
      for(i=0; i<10; i++) ptrA[i] = i;
    }

   b = func(ptrA, ret1); /* pass an uninitialized array to a function */

   if(ret2 != 1) {                   /* the value of ret2 = 1 */
      for(i=0; i<10; i++) printf("%d", ptrA[i]);
    }
   free(ptrA);    
    
   if(ret2==0) printf("Variable b=%d", b); 

   return EXITCODE_OK; 
}
