/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_6_d_in.c
*
*    Test description:	Read an uninitialized element from a dynamically allocated array
*			using pointer arithmetic. The array is partly initialized 
*			using an array of indexes that is read from a file index_array.txt.
*                       index_array.txt is filled up such that '1' is missed.
*
*    Error line:        71
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			dymically allocated array
*			main function
*			pointer arithmetic
*			int
*
*    Last modified:	June 2, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
    int *ptrA, b = 0, *ptrB;
    int i, index[N];
    FILE *fp;
    
    if((fp = fopen("index_array.txt", "r"))==NULL)
     {
       printf("Cannot open a file index_array.txt!\n");
       exit(EXITCODE_ERROR);
     }
    for(i=0; i<N; i++)
     { 
       if(feof(fp)) rewind(fp);
       fscanf(fp, "%d", &index[i]);
     }  
    ptrA = (int *)malloc(N*sizeof(int));
    if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

    for(i=0; i<N; i++) ptrA[index[i]] = i; 
    fclose(fp);

    ptrB = ptrA;

    b = b + *(ptrB+1); /* read an uninitialized element */

    ret();
    if(ret1 != 1) {                   /* the value of ret1 = 1 */
      for(i=0; i<N; i++) printf("%d", ptrA[i]);
    }
    if(ret2==0) printf("Variable b=%d", b); 
    free(ptrA);     

    return EXITCODE_OK; 
}
