/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_7_d_ul.c
*
*    Test description:	Declare a pointer in main function,
*			pass it uninitialized to a function,
*			and read using it.
*
*    Error line:        49
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_A_7_d_ul_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			uninitialized pointer
*			function
*			read
*			unsigned long int
*
*    Last modified:	June 2, 2005 
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(unsigned long int *ptrA, int ret1);

int main(void)
{
   int a;
   unsigned long int b = 0, *ptrA;
   
   ret();
   if(ret1 != 1) ptrA = &b;

/* Pass an uninitialized pointer to a function */
   a = func(ptrA, ret1);
    
   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
 }
