/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_2_a.c
*
*    Test description:	Use an uninitialized variable of type wchar_t.
*			Declare a stack variable of type w_char 
*			in main function, pass it by pointer to a function,
*			and read it there uninitialized.
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_K_2_a_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			stack variable
*			function
*			C99 specific
*			wchar_t
*
*    Last modified:	July 7, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <wchar.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(wchar_t *ptrA, int ret1);

int main(void)
{
   wchar_t varA, c = L'A';
   wchar_t *ptrA = &varA;
   int b;

/* Read an uninitialized variable in a function */

   ret();
   if(ret1 != 1) ptrA=&c;      /* the value of ret1 = 1 */

   if(ret2 != 1) varA = L'a';  /* the value of ret1 = 2 */
   b = func(ptrA,ret1);
    
   if(b!=1) printf("Variable b=%d", b);
 
   return EXITCODE_OK;
}
