/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_3_1_a.c
*
*    Test description:	Read one element past the upper bound of 
*			a variable-length array	using a subscript. 
*			The array is declared and used in a function.
*
*    Support files:     c_K_3_1_a_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			variable-length array
*			function
*			C99 specific
*			C only
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 5, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_CONST.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

void func(int dim);

int main(void)
{
   int dim;

   dim = N;
   func(dim);

   return EXITCODE_OK;
}
