/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_3_3_a.c
*
*    Test description:	Read one element past the second dimension bound but within
*			a variable-length multidimensional array using a subscript. 
*			The array is declared and used in a function.
*			The file must be compiled with file c_K_3_3_a.c
*
*    Error line:        46
*
*    Keywords:		out-of-bounds
*			variable-length array
*			array indexing
*			multidimensional array
*			function
*			C99 specific
*			C only
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	June 5, 2005
*/

#include "TEST_PARAM.H"

void func(int dim1, int dim2)
{
    int arrayA[dim1][dim2], varA;
    int i,j;
    
    for(i=0; i<dim1; i++){ 
        for(j=0; j<dim2; j++) arrayA[i][j] = i+j;
     }
 
 /* read one element past the second dimension bound */
 
    varA = arrayA[0][j] - dim1;  

    ret();
    if(ret1!=1) printf("Variable varA=%d", varA);
    if(ret2!=1) {for(i=0;i<dim1;i++) printf("arrayA[%d][0]=%d",i,arrayA[i][0]); }
}

