/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_3_3_d.c
*
*    Test description:	Write K elements past the upper bound of
*			a variable-length multidimensional array using a subscript. 
*			The array is declared and used in a function.
*			The file must be compiled with file c_K_3_3_d.c
*
*    Error line:        42
*
*    Keywords:		out-of-bounds
*			variable-length array
*			array indexing
*			multidimensional array
*			function
*			C99 specific
*			C only
*			write
*                       int
*
*    Last modified:	June 5, 2005
*/

#include "TEST_PARAM.H"

void func(int dim1, int dim2)
{
    int arrayA[dim1][dim2];
    int i,j;
    
    for(i=0; i<dim1; i++){ 
        for(j=0; j<dim2; j++) arrayA[i][j] = i+j;
     }
    j = j + K - 1;
    arrayA[i-1][j] = dim1 + dim2;  /* write K elements past the upper bound */

    ret();
    if(ret2!=1) {for(i=0;i<dim1;i++) printf("arrayA[%d][0]=%d",i,arrayA[i][0]); }
}

