/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_5_1_h.c
*
*    Test description:	Write K elements past the upper bound of 
*			a single-dimensional stack array declared and used 
*			in an inline function. Use pointer reference.
*
*    Error line:        49
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			inline function
*			C99 specific
*			write
*                       int
*
*    Last modified:	July 7, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

inline void func(void)
{
   int arrayA[N], *ptrA; 
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptrA = arrayA;
   ptrA+=N+K-1;
   *ptrA = N*i;  /* write K elements past the upper bound */

   ret();
   if(ret2!=1) {for(i=0;i<N;i++) printf("ptrA[%d]=%d",i,ptrA[i]); }
}

int main(void)
{
   func();
   return EXITCODE_OK;
}
