/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_5_2_e.c
*
*    Test description:	Read K elements before the lower bound of 
*			a dynamically allocated array declared and used 
*			in an inline function. 
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*
*    Error line:        59
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			inline function
*			C99 specific
*			read
*                       int
*
*    Last modified:	July 7, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

inline void func(void)
{
   int *arrayA, *ptrA, varA;
   int i;

   arrayA = (int *)malloc(N*sizeof(int));
   if(!arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptrA = arrayA;
   ptrA-=K;
   varA = *ptrA;  /* read K elements before the lower bound */

   ret();
   if(ret1!=1) printf("Variable varA=%d", varA);
   if(ret2!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d",i,arrayA[i]); }
   free(arrayA);
}

int main(void)
{
   func();
   return EXITCODE_OK;
}
