/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_1_1_c.c
*
*    Test description:	Deallocate memory that has never been allocated. 
*                       Call free() in a function using a pointer 
*                       pointed to global memory.
*
*    Error line:        50
*
*    Support files:     Not needed
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory deallocation error
*                       deallocate memory with incorrect pointer
*                       free global memory
*                       function
*			free()
*                       int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int arrayA[N];

int func(void)
{
    int *ptrA;
    int i;

    ptrA = arrayA;
    for(i=0; i<N; i++) ptrA[i] = N - i;
    ret();
    if(ret2 != 1) {                   /* the value of ret2 = 1 */
      for(i=0; i<N; i++) printf("%d", ptrA[i]);
     }
    free(ptrA);  /* deallocate global memory */

    return EXITCODE_OK;
}

int main(void)
{
    return func();
}


