/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_1_4_c.c
*
*    Test description:	Deallocate memory with a dangling pointer
*                       in main function using a global pointer repointed 
*                       to a freed pointer in a function.
*                       The file must be compiled with file c_G_1_4_c.c
*
*    Keywords:		deallocate memory with dangling pointer
*                       function
*                       moved pointer
*                       freed pointer
*                       global pointer
*			free()
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int *ptrA, *ptrB;

void func()
{
   int i;

   ptrB = (int *)malloc(N*sizeof(int));
   if(!ptrB)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrB[i] = N - i;
   for(i=0;i<N;i++) *ptrA = *ptrA + ptrB[i];
   
   free(ptrB); 

   ret();
   if(ret1!=1) printf("%d\n", *ptrA);     /* the value of ret1 = 1 */
   free(ptrA);
   ptrA = ptrB;
}

