/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_2_b.c
*
*    Test description:	Reallocate memory that has been freed. 
*                       Allocate memory in main function, deallocate it 
*                       in a function using a pointer passed by address, 
*                       and then reallocate the memory in main function.
*                       The file must be compiled with file c_G_2_2_b.c
*
*    Keywords:		memory reallocation error
*                       reallocate freed memory
*                       function
*                       freed pointer
*			realloc()
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

void func(int **ptrA)
{
   int sum = 0;
   int i;
   
   for(i=0;i<N;i++) sum = sum + (*ptrA)[i];
    
   free(*ptrA);

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */
}


