/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_4_c.c
*
*    Test description:	Reallocate memory with a dangling pointer
*                       in main function using a global pointer repointed 
*                       to a freed pointer in a function.
*                       
*    Error line:        58
*
*    Support files:     c_G_2_4_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		reallocate memory with dangling pointer
*                       function
*                       freed pointer
*                       global pointer
*			realloc()
*			int
*
*    Last modified:	June 30, 2005
*/

#include <stdlib.h>
#include <stdio.h>
#include "TEST_CONST.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int *ptrA, *ptrB;

void func();

int main(void)
{
   ptrA = (int *)malloc(sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   *ptrA = 0;
   func(); 

   ptrA = (int *)realloc(ptrA, K*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   free(ptrA);

   return EXITCODE_OK;
}


