/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_2_3_e.c
*
*    Test description:	Read one element past the upper bound of an array
*			of structures declared and used in a function. 
*			Use an array of indexes.
*			The file must be compiled with file c_E_2_3_e.c
*
*    Error line:        46
*
*    Keywords:		out-of-bounds
*			array indexing
*			array of structures
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c;
   int i, index[N];
   struct aab {
       char * nm;
       int b;
   } ss[N];

   for (i=0; i<N; i++)
    {
      index[i] = N-i;
      ss[i].b = i;
    }
   c = ss[index[0]].b;  /* read one element past the upper bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}

