/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_2_4_d.c
*
*    Test description:	Write one element past the upper bound of a stack array
*			that is a member of a structure declared in a function. 
*			Use an array of indexes.
*			The file must be compiled with file c_E_2_4_d.c
*
*    Error line:        47
*
*    Keywords:		out-of-bounds
*			array indexing
*			stack array
*			function
*			structure
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c = 0, sum = 0;
   int i, index[N];
   struct aab {
       char * nm;
       int arrayA[N];
   } ss;

   for (i=0; i<N; i++)
    {
      index[i] = N-i;
       ss.arrayA[i] = i;
    }
   ss.arrayA[index[0]] = c;  /* write one element past the upper bound */
   for(i=0; i<N; i++)         /* use elements of the array */
        sum = sum + ss.arrayA[i];   /* to prevent code elimination */ 

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

