/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_2_8_e.c
*
*    Test description:	Write K elements past the upper bound of an array
*			of structures declared and used in a function. 
*			Use an array of indexes.
*			The file must be compiled with file c_E_2_8_e.c
*
*    Error line:        43
*
*    Keywords:		out-of-bounds
*			array indexing
*			array of structures
*			function
*			write
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c = 0, sum = 0;
   int i, index[N];
   struct aab {
       char * nm;
       int b;
   } ss[N];

   for (i=0; i<N; i++)
    {
      index[i] = N+K-i;
      ss[i].b = i;
    }
   ss[index[1]].b = c;  /* write K elements past the upper bound */
   for(i=0; i<N; i++)            /* use elements of the array */
       sum = sum + ss[i].b;      /* to prevent code elimination */ 

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

