/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_3_5_d.c
*
*    Test description:	Read K elements before the lower bound of
*			a multidimensional stack array that is a member of
*			a structure declared in a function.
*			The file must be compiled with file c_E_3_5_d.c
*
*    Error line:        45
*
*    Keywords:		out-of-bounds
*			array indexing
*			multidimensional array
*			function
*			structure
*			read
*                       int
*
*    Last modified:	July 29, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c;
   int i, j;
   struct aab {
       char * nm;
       int arrayA[N][N];
   } ss;

   for(i=0; i<N; i++) {
       for(j=0; j<N; j++)
           ss.arrayA[i][j] = i+j;
        }
   j = j - N - K;
   c = ss.arrayA[0][j];  /* read K elements before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}

