/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_5_7_a.c
*
*    Test description:	Read K elements past the upper bound of  
*			a dynamically allocated multidimensional array 
*			using a subscript.
*			Declare and use the array in a block.
*
*    Error line:        72
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			multidimensional array
*			main function
*			block
*			read
*                       int
*
*    Last modified:	July 30, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int a;
   int i, j;

   {
     int **ptr;
     ptr = (int **)malloc(N*sizeof(int *));
     if(!ptr)
      { 
        printf("Out of memory.\n");
        exit(EXITCODE_ERROR);
      }   
     for(i=0; i<N; i++)
      {
         ptr[i] = (int *)malloc(N*sizeof(int));
         if(!ptr[i])
          { 
            printf("Out of memory.\n");
            exit(EXITCODE_ERROR);
          }   
      }
     for(i=0; i<N; i++)
         for(j=0; j<N; j++)
             ptr[i][j] = i+j;
     j = j + K - 1;
     a = ptr[N-1][j];  /* read K elements past the upper bound */

     for(i=0; i<N; i++)
         free(ptr[i]);
     free(ptr);
   }
   
   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable a=%d", a);
   } 
   
   return EXITCODE_OK; 
}
