/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_5_8_e.c
*
*    Test description:	Write K elements past the upper bound of 
*			a dynamically allocated multidimensional array 
*			using a subscript.
*			The array is declared using a global pointer to pointer;
*			allocated and used in a function.
*			The file must be compiled with file c_E_5_8_e.c
*
*    Error line:        64
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			multidimensional array
*			global pointer to pointer
*			function
*			write
*                       int
*
*    Last modified:	July 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int **ptr;

int func(void)
{
   int b = 0, sum = 0;
   int i, j;

   ptr = (int **)malloc(N*sizeof(int *));
   if(!ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
    {
       ptr[i] = (int *)malloc(N*sizeof(int));
       if(!ptr[i])
        { 
          printf("Out of memory.\n");
          exit(EXITCODE_ERROR);
        }   
    }
   for(i=0; i<N; i++)
       for(j=0; j<N; j++)
           ptr[i][j] = i+j;
   j = j + K - 1;
   ptr[N-1][j] = b;  /* write K elements past the upper bound */
   for(i=0; i<N; i++)         /* use elements of the array */
       sum = sum + ptr[1][i];   /* to prevent code elimination */ 

   for(i=0; i<N; i++)
       free(ptr[i]);
   free(ptr);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

