/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_H_1_b.c
*
*    Test description:	File I/O error. 
*			Write to a file that is not opened.
*
*    Error line:        43
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		file I/O error
*                       write
*
*    Last modified:	June 30, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   char ch;
   FILE *fp;
    
   ret();
   if(ret1!=1) fp = fopen("file_read.txt", "w"); /* the value of ret1 = 1 */
   ch = 'A';

   fputc(ch, fp); /* write to a file that is not opened */

   if(ret2!=1) printf("%c\n", ch);     /* the value of ret2 = 1 */
    
   return EXITCODE_OK;
}
