/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_H_5_b.c
*
*    Test description:	File I/O error. 
*			Close a file twice that is opened once.
*			Open the file in main function,
*			then close it in a function using passed pointer,
*			then close it again in main function.
*
*    Error line:        52
*
*    Support files:     file_write.txt, index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_H_5_b_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		file I/O error
*
*    Last modified:	June 30, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(FILE *fp);

int main(void)
{
    FILE *fp;
    
    if((fp = fopen("file_read.txt", "r"))==NULL)
     {
       printf("Cannot open the file!\n");
       exit(EXITCODE_ERROR);
     }
    func(fp);   /* close the file in the function */
    fclose(fp); /* close the file second time */
       
    return EXITCODE_OK;
}
