/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_2_b.c
*
*    Test description:	Reset a pointer pointing to a block of memory 
*                       to point somewhere else 
*                       leaving the first block of memory unreferenced.   
*                       Use a pointer in a function to allocate memory,
*                       then reset it in main function to point to another
*                       block of memory.
*
*    Error line:        46
*
*    Support files:     c_I_2_b_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory leak
*                       unreferenced memory
*			reset a pointer
*			function
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int *func(void);

int main(void)
{
   int *ptrA, arrayA[N], sum = 0;
   int i;
  
   ptrA = func();
   for(i=0;i<N;i++) arrayA[i] = i;
   ptrA = arrayA;
   for(i=0;i<N;i++) sum = sum + *(ptrA++);
   sum = sum/N;

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */

   return EXITCODE_OK;
}
