/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_3_b.c
*
*    Test description:	Allocate a block of memory and deallocate only part of it.
*                       Allocate memory in main function, pass the pointer by address 
*                       to a function, move it there to point to the middle 
*                       of the memory block, then deallocate the memory in main function.
*
*    Error line:        60
*
*    Support files:     c_I_3_b_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory leak
*			function
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(int **);

int main(void)
{
   int *ptrA, sum = 0;
   int i;


   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];

   func(&ptrA);      /* move the pointer to the middle of the memory block */
    
   ret();
   if(ret1!=1) printf("%d\n", *ptrA);     /* the value of ret1 = 1 */
   if(ret2!=1) printf("%d\n", sum);       /* the value of ret2 = 1 */
  
   free(ptrA);

   return EXITCODE_OK;
}
