/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_5_e.c
*
*    Test description:	Read K elements before the lower bound of an array
*			of structures declared and used in a function. 
*			Use pointer reference.
*			The file must be compiled with file c_F_1_5_e.c
*
*    Error line:        46
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			array of structures
*			function
*			read
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c; 
   int i;
   struct aab {
       char * nm;
       int b;
   } ss[N], *ptr;

   for(i=0; i<N; i++)
       ss[i].b = i;
   ptr = ss;
   ptr-=K;
   c = ptr->b;  /* read K elements before the lower bound  of the array of structures */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 
   
   return ret2; 
}
