/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_6_a.c
*
*    Test description:	Write K elements before the lower bound of 
*			a single-dimensional stack array in a block.
*			Use pointer reference.
*
*    Error line:        51
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			main function
*			block
*			write
*                       int
*
*    Last modified:	July 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   int a = 0, *ptr, sum = 0; 
   int i;

   {
     int arrayA[N];
     for(i=0; i<N; i++)
         arrayA[i] = i;
     ptr = arrayA;
     ptr-=K;
     *ptr = a;  /* write K elements before the lower bound */
     for(i=0; i<N; i++)           /* use elements of the array */
         sum = sum + arrayA[i];   /* to prevent code elimination */ 
    }

   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable sum=%d", sum);
   } 
   
   return EXITCODE_OK; 
}
