/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_8_d.c
*
*    Test description:	Write K elements past the upper bound of 
*			a single-dimensional stack array declared and used 
*			in a function as a member of a structure. 
*			Use pointer reference.
*			The file must be compiled with file c_F_1_8_d.c
*
*    Error line:        49
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			function
*			structure
*			write
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c = 0, *ptr, sum = 0; 
   struct aab {
       char * nm;
       int arrayA[N];
   } ss;
   int i;

   for(i=0; i<N; i++)
       ss.arrayA[i] = i;
   ptr = ss.arrayA;
   for(i=0; i<N; i++)              /* use elements of the array */
       sum = sum + ptr[i];   /* to prevent code elimination */ 
   ptr+=(N+K-1);
   *ptr = c;  /* write K elements past the upper bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}
