/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_J_2_1_c.c
*
*    Test description:	Out-of-bounds memory access of a global array.
*			Read one element past the upper bound of a global array
*			in a function. Use pointer reference.
*			The file must be compiled with file c_J_2_1_c.c
*
*    Error line:        43
*
*    Keywords:		out-of-bounds
*			pointer reference
*			global array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 1, 2005
*/

#include "TEST_PARAM.H"

extern int arrayA[N];

void func(void)
{
   int varA, *ptrA; 
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = N-i;
   ptrA = arrayA;
   ptrA+=N;
   varA = *ptrA;  /* read one element past the upper bound */

   ret();
   if(ret1!=1) printf("Variable varA=%d", varA);
   if(ret2!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d  ",i,arrayA[i]); }
   
}
