/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt . */
/*
*    Test name:		c_J_3_4_a.c
*
*    Test description:	Access deallocated memory.
*                       Point a pointer to a local array in a function,
*                       then try to read the memory after exit the function 
*                       using the pointer. Return the pointer from the function 
*                       and read using it in main function.
*
*    Error line:        55
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		access deallocated memory
*                       pointer reference
*                       dangling pointer
*                       function
*                       read
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int* func(void)
{
   int *ptrA, i;
   int arrayA[N];
   for(i=0;i<N;i++) arrayA[i] = N - i;
   ptrA = arrayA;
   ret();
   if(ret1!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d  ",i,(ptrA)[i]); }
   
   return ptrA;
}

int main(void)
{
  int *ptrA, varA;
  int i;

  ptrA = func();
  
  varA = *ptrA;   /* read from deallocated memory */
  if(ret2!=1) printf("Variable varA=%d", varA);

  return EXITCODE_OK;
}


