/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_D_1_5_b.c
*
*    Test description:	Use strcat(str1,str2) when str1 is not long enough  
*                       to hold both str1 and str2.
*                       The strings are declared in stack memory.
*
*    Error line:        44
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		string
*                       stack memory
*                       write overflow
*                       strcat
*
*    Last modified:	June 17, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
  char str1[15];
  char str2[]="2nd string";

  strcpy(str1,"1st string");
  strcat(str1,str2);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n",str1); /* use the value to prevent code elimination */

  return EXITCODE_OK; 
}
