/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:         c_D_1_7_d.c
*
*    Test description:	Use not null-terminated string as a first argument 
*                       of function strchr(str1, c).
*                       The string is declared in stack memory.
*
*    Error line:        49
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:          string
*                       stack memory
*                       read overflow
*                       not null-terminated string
*                       strchr
*
*    Last modified:     June 20, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
  char str1[]="first";
  char str2[]="last";
  char c = 'a';
  char *p;
  int i;

  for(i=0; i<sizeof(str1);i++)
      str1[i]='x';
  p = strchr(str1,c);
  if (p!=NULL) *p = 'A';

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n %s \n", str1, str2); 

  return EXITCODE_OK;
}
