/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:         c_D_1_7_e.c
*
*    Test description:	Use not null-terminated string as a first argument 
*                       of function strpbrk(str1, str2).
*                       The strings are declared in stack memory.
*
*    Error line:        48
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:          string
*                       stack memory
*                       read overflow
*                       not null-terminated string
*                       strpbrk
*
*    Last modified:     June 20, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
  char str1[]="first string";
  char str2[]="la";
  char *p;
  int i;

  for(i=0; i<sizeof(str1);i++)
      str1[i]='x';
  p = strpbrk(str1,str2);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
   {
    if (p==NULL) printf("No str2 in str1");
   }

  return EXITCODE_OK;
}
