/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_12_j.c
*
*    Test description:	Use cast operator with an uninitialized variable
*			that is declared and used in main function.
*			Convert long int to int.
*
*    Error line:        46
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			main function
*                       cast operator
*                       explicit type conversion
*                       convert long int to int
*
*    Last modified:	June 22, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   long int varA;
   int varB = 1234;
    
   ret();
   if(ret1 != 1) varA = 123456789;

   varB = varB + (int)varA;      /* convert long to int */ 

   if(ret2!=1) printf("%d", varB);     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
