/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_3_d_in.c
*
*    Test description:	Declare a stack array in main function,
*			point a pointer to the array,
*			pass the pointer to a function,
*			and read it there uninitialized.
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_A_3_d_in_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			stack array
*			function
*			pointer
*			int
*
*    Last modified:	March 1, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(int *ptrA, int ret1);

int main(void)
{
   int arrayA[10];
   int *ptrA;
   int b, i;

    ret();
    if(ret1 != 1) {
       for(i=0; i<10; i++) arrayA[i] = i;
       }
    ptrA = arrayA;
    
/* Read an uninitialized array in a function */
    
   b = func(ptrA, ret1); 

   if(ret2==0) {                  /* the value of ret2 = 1 */
      printf("Variable b=%d", b);
   } 

   return EXITCODE_OK; 
}
