!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_1_b.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation twice
!                        for a pointer in a subroutine
!                        contains in a main program 
!                        
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        subroutine contains in a main program
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************
program tests
  implicit none
  integer :: n=10, m=20
  double precision :: var
  double precision, allocatable, dimension(:,:) :: arr1
  allocate(arr1(n,m))
  call sub(n,m,var)
  print *,var
  deallocate(arr1)

  contains
    subroutine sub(n,m,var)
      integer, intent(in) :: n,m
      double precision, intent(inout) :: var
      double precision, allocatable, dimension(:,:) :: arr ! DECLARE
      
      integer :: i,j
      do i=1,n
         do j=1,m
            arr1(i,j) = dble(i*j)
         enddo
      end do
      var = arr1(n,m)
      deallocate(arr)   ! deallocate ERROR 
      return
    end subroutine sub
end program tests
