!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_2_c.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation twice
!                        for pointer in a subroutine which
!                        declares outside the main program 
!                        
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        a subroutine contains in a main program 
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************
program tests
  implicit none
  integer :: n=10, m=20
  integer :: i,j
  double precision :: var
  double precision, allocatable, dimension(:,:) :: arr1 
  allocate(arr1(n,m))
  do j=1,m
     do i=1,n
        arr1(i,j) = real(i*j)
     end do
  end do
  call sub(n,m,arr1)
  var = sum(arr1(1,:))
  print *,var
  deallocate(arr1)
end program tests

subroutine sub(n,m,arr1)
  integer, intent(in) :: n,m
  double precision, intent(inout) :: arr1(n,m)
  double precision, allocatable, dimension(:,:) :: arr ! DECLARE
  
  integer :: i,j
  do i=1,n
     do j=1,m
        arr1(i,j) = arr1(i,j)*2.0
     enddo
  end do
  deallocate(arr)  ! deallocate  ERROR 
  return
end subroutine sub
