!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_3_1_a.f90
!
!     Summary:           Memory Allocation and Deallocation Errors
!
!     Test description:  try to declare very big stack arrays/pointer in the procedure 
!                        The error occurs in the internal subroutine.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          stack overflow
!                        internal subroutine
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none
  double precision :: var
  integer :: m
  m=1000000
  var = 0.0
  call sub(var,m)
  print *,var
  contains
    subroutine sub(var,m)
      double precision, intent(inout):: var
      integer, intent(in) :: m
      double precision :: arr(m,m)  ! Stack allocation ERROR occurs here.
      
      integer :: i,j
      
      do i=1,m
         do j=1,m
            arr(i,j) = dble(i*j)
         end do
      end do
      var = arr(m/2,m/2)
      return 
    end subroutine sub
end program test
