!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_1_3_b_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D statically allocated array 
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rstack
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: N=20
  type(S), dimension(:) :: arr(1:N)
  type(S) :: a
  integer :: indx

! initialize the array
  do indx=1, N
     arr(indx) % num = indx
     arr(indx) % gender = 'f'
  end do
  A%NUM = 0
  do indx = -10, N
     a % num = a % num+ arr(indx) % num    ! Reading beyond the bound ERROR
  end do
  print *,'a%num=',a%num
  stop
end program rstack
