!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_1_5_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D statically allocated array
!                        The array is derived data type
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived data type data type 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rstack
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: N=20
  type(S), dimension(:) :: arr(N) ! DECLARE
  integer :: indx
! initialize the array
  do indx=1, N
     arr(indx) % num = indx
     arr(indx) % gender = 'f'
  end do

  do indx = 1, N
     arr(indx) % num = arr(indx+1) % num - 2*arr(indx)%num + arr(indx-1)%num  ! Reading beyond the bound  ERROR
  end do
  print *,'arr(1)=',arr(1)
  stop
end program rstack
