!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_3_3_b_i.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated array
!                        The lower bounds of the array are not equal to 1 
!                        The array is integer.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        integer array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program rstack
  implicit none
  integer, parameter :: M1=-10, M2=10, N1=50, N2=100
  integer :: arr(M1:M2,N1:N2), a
  integer :: i, j
  do i=M1,M2
     do j=N1, N2
        arr(i,j) = dble(j)
     end do
  end do
  a = dble(1000)
  i = i + 20
  j = N1 + (N2-N1)/2
  a = arr(I,j)       ! read out of bounds ERROR
  print *,'a=',a
  stop
end program rstack
