!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_1_3_d_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated array
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap
  implicit none
 type S
     integer :: num
     character :: gender
  end type S
  type(S), dimension(:), allocatable :: ptr
  integer :: a
  integer :: i,istat, n

  n=20
  allocate(ptr(1:n), STAT= istat)
  if (istat == 0) then
     do i=1,n       
        ptr(i)%num = i
        ptr(i)%gender = 'f'
     end do
    a = 0.d0
    do i = 1, N+10
       a = a + ptr(i)%num  ! read out of bounds ERROR
    end do
    print *,'a=',a
    
  end if
  deallocate(ptr,STAT=istat)
end program rheap
