!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_2_1_b_r.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D dynamically allocated array
!                        The array is real.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        real array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program rheap
  implicit none
  integer, parameter :: N=20, M=10
  real, allocatable, dimension(:,:) :: ptr
  real :: a
  integer :: i, j, istat
  allocate(ptr(N,M),STAT=istat)
  if (istat == 0) then
     do j=1, M
        do i=1, N
           ptr(i,j) = i*j
        enddo
     end do
     a = ptr(i-1,j+20) ! ERROR 
     print *,'a=',a
     deallocate(ptr)
  end if
  stop
end program rheap
