!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_2_4_b_i.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D dynamically allocated array
!                        The array is integer.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        integer array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program wstack
  implicit none
  integer, parameter :: N=20, M=10
  integer, allocatable, dimension(:,:) :: ptr
  integer :: a
  integer :: i, j, istat
  a = 30
  allocate(ptr(N,M),STAT=istat)
  if (istat==0) then
     do j=1, M
        do i=1, N
           ptr(i,j) = dble(i*j)
        enddo
     end do
     ptr(i+20,j-1) = a     ! write out of bounds  ERROR
     print *,'ptr(1,1)=',ptr(1,1)
     deallocate(ptr)
  endif
  stop
end program wstack
