!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_3_5_4_a_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D explicit-shaped array 
!                        where the total number of array elements
!                        in the dummy argumentis less than actual argument
!                        in an external subroutine
!                        The array is double precision.
!
!     Support files:     F_F_3_5_4_a_d_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none

  integer,parameter :: N=100
  double precision :: arr(N), var
  integer :: i,j,indx

  do i=1,n
     arr(i) = SQRT(dble(i))
  end do

  var = sqrt(dble(n))
  call sub(arr,var)
  print *,var, arr(1)
end program test
