!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_4_1_2_c_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of assumed-size A(M1:M2,*)  
!                        2 D array dummy argument in an internal subroutine
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  integer,parameter :: N=10, m=20
  double precision :: arr(n,m), var
  integer :: i,j,indx
  do j=1,m
     do i=1,n
        arr(i,j) = dble(i*j)
     end do
  end do
  var = 1.d0
  call sub(arr,var,n,m)
  print *,var, arr(n,m)
contains
  subroutine sub(arr1,var,n,m)
    integer,intent(in) :: n,m
    double precision, intent(inout):: arr1(n,*), var  ! DECLARE
    
    integer :: I,J
    double precision :: tmp
    call random_number(tmp)
    if (sin(tmp*arr(1,1))>1.0) then
       j=1
    else
       j = m+1
    end if
    i = n/2
    arr1(i,j) = var*2.0  ! write out of bounds ERROR 
    print *,arr1(1,1), var
    return
  end subroutine sub
end program tests

