!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_K_1_a.f90
!
!     Summary:           non-conforming use of fortran array 
!                        elemental user defined subprograms
!
!     Test description:  non-conforming use of Fortran 90 arrays
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          non-conforming use of Fortran 90 arrays
!                        elemental user defined subprogram
!
!     Last modified:     06/10/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  INTERFACE
     ELEMENTAL double precision FUNCTION mytanh(X)
       double precision, INTENT(IN) :: X
     END FUNCTION mytanh
  END INTERFACE
  double precision, allocatable :: arr1(:), arr2(:)
  integer :: n, i,j

  N=100
  allocate(arr1(n), arr2(N+1))

  forall (i=1:N)
     arr1(i) = dble(i)/dble(N)  
  end forall

  arr2 = mytanh(arr1)  ! ERROR
  print *,arr2(1)  
end program tests
  
ELEMENTAL double precision function  mytanh(x)
  implicit none
  double precision, intent(in) :: x

  mytanh = (exp(x)-exp((-1.0)*x))/(exp(x)+exp((-1.0)*x))
  return
end function mytanh

