!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_J_1_e.f90
!
!     Summary:           memory leak 
!
!     Test description:  reset the pointer to somewhere else or nullify it
!                        before deallocate the pointer
!
!     Support files:     not needed
!
!     Env. requirements: 
!
!     Keywords:          memory leak
!
!     Last modified:     06/09/2005
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none
  integer, parameter :: m=10
  double precision :: var
  var = 0.d0
  var =  sub(m)
  print *,var
  contains
    double precision function sub(m)
      integer, intent(in) :: m
      double precision, pointer, dimension(:) :: ptr1,ptr2  ! DECLARE
      integer :: n=20,count,i
      sub = 0.d0
      do count = 1, m
         allocate(ptr1(n))    
         ptr2 => ptr1
         do i=1,n
            ptr2(i) = dble( count + i)
         end do
         sub = sub + ptr1(n)
         nullify(ptr1)   ! ERROR 
      end do
      deallocate(ptr2)
      return
    end function sub
  end program test
