!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_1_1_2_c_d.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated pointer 
!                        The array is double precision.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program wstack
  implicit none
  double precision, dimension(:), target :: arr(20)
  double precision, dimension(:), pointer :: ptr
  double precision :: a = 20.d0
  integer :: indx

  do indx=1,20
     arr(indx) = dble(indx)
  end do

  ptr => arr
  indx = indx-21
  ptr(indx) = a*10.0      ! write out of bounds ERROR
  print *,'ptr(1)=',ptr(1)   
  stop
end program wstack
