!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_1_2_3_c_r.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated pointer 
!                        The array is real.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        real array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap3
  implicit none

  real, dimension(:), pointer :: ptr
  real :: a
  integer :: i,istat,n

  n=20 
  allocate(ptr(1:n), STAT= istat)
  if (istat == 0) then
     do i=1,n
        ptr(i) = dble(i) 
     end do
!   now i=21
    do i=10,10+n
	a = ptr(i)   ! reading ptr beyond the bound 10 ~ 10+N  ERROR
	print *,'a=',a
    enddo
  end if
  deallocate(ptr,STAT=istat)
end program rheap3
