!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_2_1_c_t.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated pointer 
!                        The lower bounds of the array are equal to 1 
!                        The array is derived data type.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap
  implicit none
   type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: N=20, M=10
  type(S), allocatable, dimension(:,:) :: ptr
  integer :: a
  integer :: i, j, istat

! initialize the array
  allocate(ptr(N,M),STAT=istat)
  if (istat == 0) then
     do j=1, M
        do i=1, N
           ptr(i,j)%num = i*j
           ptr(i,j)%gender = 'm'
        enddo
     end do
     a = ptr(i-1,j-M-1)%num    ! Reading beyond the bound: arr(N,0), i=N+1, j=M+1  ERROR 
     print *,'a=',a
     deallocate(ptr)
  end if
  stop
end program rheap
