!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_2_4_a_d.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated pointer 
!                        The lower bounds of the array are equal to 1 
!                        The array is double precision.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
! * double precision array is used.

program wstack
  implicit none
  integer, parameter :: N=20, M=10
  double precision, allocatable, dimension(:,:) :: ptr
  double precision :: a
  integer :: i, j, istat
  a = 30
! initialize the array
  allocate(ptr(N,M),STAT=istat)
  if (istat==0) then
     do j=1, M
        do i=1, N
           ptr(i,j) = dble(i*j)
        enddo
     end do
     
     ptr(i,j-1) = a ! writing Reading beyond the bound: arr(N+1,M), i=N+1, j=M+1   ERROR 
     print *,'ptr(1,1)=',ptr(1,1)
     deallocate(ptr)
  endif
  stop
end program wstack
