!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_4_1_d_r.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 7 D dynamically allocated pointer
!                        The array is real.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        real array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------


program rheap
  implicit none
  integer, parameter :: N1=2, n2 = 4, n3 = 6, n4 = 8, n5=10, n6=12, n7=15
  real, allocatable, dimension(:,:,:,:,:,:,:) :: ptr 
  real :: a
  integer :: i1,i2,i3,i4,i5,i6,i7, istat
! initialize the array
  allocate(ptr(n1, n2, n3, n4, n5, n6, n7),STAT=istat)
  if (istat == 0 ) then
     do i7=1, n7
        do i6=1, n6
           do i5=1, n5
              do i4=1, n4
                 do i3=1, n3
                    do i2=1, n2
                       do i1=1, n1
                          ptr(i1,i2,i3,i4,i5,i6,i7) = i1+i2+i3+i4+i5+i6+i7
                       enddo
                    end do
                 end do
              end do
           end do
        end do
     end do
     a = ptr(i1-1,i2-1,i3-1,i4-n4-10,i5-1,i6-1,i7-1)  ! ERROR
     print *,'a=',a
     deallocate(ptr)
  end if
  ! Reading beyond the bound: arr(n1,n2,n3,-9,n5,n6,n7)
  stop
end program rheap
