!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_E_3_4_1_a.f90
!
!     Summary:           string out-of-bounds 
!
!     Test description:  string out-of-bounds for 1D string array
!                        character *(*) A as dummy argument
!                        in an internal subroutine; 
!                        the string on right hand side is declared in
!                        the main program; 
!                        write through array section 
!
!     Support files:     not needed 
!
!     Env. requirements: not needed
!
!     Keywords:          string out-of-bounds 
!                        in an internal subroutine 
!
!     Last modified:     05/20/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none

  integer, parameter :: strlen=20
  character(len=strlen) :: str1, str2  ! DECLARE
  integer :: i, j

  str2 = '12345678901234567890'
  print *, str2
  call sub(str1)
  print *, str1

  contains
    subroutine sub(str1)
      character *(*), intent(inout) :: str1 
      integer :: I1, I2, strlen
      strlen = len(str1)
      I1 = 0
      I2 = I1+strlen-1
      str1 = str2(I1:I2)    ! read out of bounds ERROR
      return
    end subroutine sub
  end program tests
